 /*
 * StatQuantGui.java
 */ 

package nl.uu.chem.bioinformatics.statquant.gui;

import org.jdesktop.application.SingleFrameApplication;
import java.awt.Window;

/**
 * The main class of the application.
 */
public class StatQuantGui extends SingleFrameApplication {

    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
       SplashScreen splash = new SplashScreen();
       splash.setVisible(true);
       show(new StatQuantGuiView(this));
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of StatQuantGui
     */
    public static StatQuantGui getApplication() {
        return org.jdesktop.application.Application.getInstance(StatQuantGui.class);
    }

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {

        launch(StatQuantGui.class, args);
    }
}
