/*
 * FastaSequence.java
 * 
 * Created on Oct 4, 2007, 5:06:02 PM
 * 
 * A sequence obtained from a fasta file. Contains an identifier and a description field.
 */

package nl.uu.chem.bioinformatics.statquant.model;

/**
 *
 * @author Toorn101
 */
public class FastaSequence {
    String sequence;
    String identifier;
    String description;
            
    /**
     * Create a new object and initialize them with all data
     * @param sequence the sequence
     * @param identifier an identifier
     * @param description a simple text description of the identifier
     */
    public FastaSequence(String sequence, String identifier, String description) {
        this.sequence = sequence;
        this.identifier = identifier;
        this.description = description;
    }

    /**
     * Get the description
     * @return the description
     */
    public String getDescription() {
        return description;
    }
    /**
     * Set the description
     * @param description the description as a string
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * Get the identifier
     * @return the identifier
     */
    public String getIdentifier() {
        return identifier;
    }

    /**
     * Set the identifier
     * @param identifier the identifier
     */
    public void setIdentifier(String identifier) {
        this.identifier = identifier;
    }

    /**
     * get the sequence
     * @return the sequence
     */
    public String getSequence() {
        return sequence;
    }

    /**
     * set the sequence
     * @param sequence the sequence
     */
    public void setSequence(String sequence) {
        this.sequence = sequence;
    }
    
    /**
     * toString will in our case always give a nice fasta line
     * @return string representation
     */
    @Override
    public String toString() {
        return ">"+identifier+" "+description+"\n"+sequence;
    }
}
