/*
 * QuantifiedAminoAcidSequence.java
 * 
 * Created on Jul 30, 2007, 12:44:07 PM
 * 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package nl.uu.chem.bioinformatics.statquant.model;

import java.util.ArrayList;
import nl.uu.chem.bioinformatics.statquant.model.AminoAcidSequence;
/**
 *
 * @author breuk102
 */
public class QuantifiedAminoAcidSequence extends AminoAcidSequence{
    
    private String peptideinfo[];
    private float ratio;
    private String modification = "";
    private String sequenceWithMods = "";
    private ArrayList<String> SequenceWithMods = new ArrayList<String>();
    /**
     * is this peptide used for the calculations? true or not (false)
     */
    private boolean checked = true;
    /**
     * List of protein ID's the peptide has been found in
     */
    private ArrayList<String> presentInProteins = new ArrayList<String>();

    public ArrayList<String> getSequenceWithMods() {
        return SequenceWithMods;
    }

    public void setSequenceWithMods(ArrayList<String> SequenceWithMods) {
        this.SequenceWithMods = SequenceWithMods;
    }

    public String getSeqWithMods(){
        String PTMString = "";
        if (this.isChecked()){
                PTMString =this.getSequenceWithMods().toString();
        }
        return PTMString;
    }
    public float getRatio() {
        return ratio;
    }
    
    public float getLogRatio(){
        Double logRatio = Math.log10(ratio) / Math.log10(2);
        return logRatio.floatValue();
    }
    
    public void setLogRatio(float LogRatio){
        Double Ratio = Math.pow(2d, (double)LogRatio);
        ratio = Ratio.floatValue();
    }

    public void setRatio(float ratio) {
        this.ratio = ratio;
    }

    public boolean isChecked() {
        return checked;
    }

    public void setChecked(boolean checked) {
        this.checked = checked;
    }

    public String getsequenceWithMods() {
        return sequenceWithMods;
    }

    public void setsequenceWithMods(String sequenceWithMods) {
        this.sequenceWithMods = sequenceWithMods;
    }
    
    
    
    public QuantifiedAminoAcidSequence() {
        super();
    }
    public QuantifiedAminoAcidSequence(String sequence) {
        super(sequence);
    }

    public String[] getPeptideinfo() {
        return peptideinfo;
    }

    public void setPeptideinfo(String[] peptideinfo) {
        this.peptideinfo = peptideinfo;
    }
     public String getModification() {
        return modification;
    }

    public void setModification(String modification) {
        this.modification = modification;
    }

    public int presentInProteinsSize() {
        return presentInProteins.size();
    }
    /**
     * Add a single protein to the protein list
     * @param protein name of the protein
     * @return if the insertion worked
     */
    public boolean addToProteinList(String protein) {
        return presentInProteins.add(protein);
    }

    /**
     * get the list of protein identifiers the peptide was found in
     * @return the list with proteins
     */
    public ArrayList<String> getPresentInProteins() {
        return presentInProteins;
    }

    /**
     * set the arraylist with proteins the peptide was found in
     * @param presentInProteins the list of proteins
     */
    public void setPresentInProteins(ArrayList<String> presentInProteins) {
        this.presentInProteins = presentInProteins;
    }
    
    /**
     * Check the proteins list to see whether the peptides are unique
     * @return true if the peptide is only found in one protein
     */
    public boolean isPeptideUnique() {
        return !(presentInProteins.size() > 1);
    }
}
