/*
 * ste_implem.java
 *
 * Created on August 20, 2007, 3:02 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nl.uu.chem.bioinformatics.statquant.util;

import flanagan.interpolation.CubicSpline;

/**
 *
 * @author madalina
 */
public class qvalue{
     
    double[] p_values;
    int p_length;
    double[] lambda_values;
    int lambda_length;
    double t_thresold;
    
    private double pi_0_estimator;
    private double[] range_pi_0;
    private double[] range;
    
    private double[] q;
    
    boolean robust = true;
    
    /** Creates a new instance of ste_implem */
    public qvalue(double[] p, int length, double[] lambda, int length_l) {
        p_length = length;
        p_values = new double[p_length];
        for(int index = 0; index < p_length; index++)
            p_values[index] = p[index];
        lambda_length = length_l;
        lambda_values = new double[lambda_length];
        for(int index = 0; index < lambda_length; index++)
            lambda_values[index]  = lambda[index];
        q = new double[p_length];
    }
    
    public qvalue(double[] p, int length) {
        p_length = length;
        p_values = new double[p_length];
        for(int index = 0; index < p_length; index++)
            p_values[index] = p[index];
        lambda_length = 100;
        lambda_values = new double[lambda_length];
        lambda_values[0] = 0;
        for(int index = 1; index < lambda_length; index++)
            lambda_values[index]  = lambda_values[index-1] + 0.01;
         q = new double[p_length];
    }
    
    public qvalue(Object[] p, int length) {
        p_length = length;
        p_values = new double[p_length];
        for(int index = 0; index < p_length; index++)
            p_values[index] =  Float.parseFloat(p[index].toString()); 
        lambda_length = 100;
        lambda_values = new double[lambda_length];
        lambda_values[0] = 0;
        for(int index = 1; index < lambda_length; index++)
            lambda_values[index]  = lambda_values[index-1] + 0.01;
        range_pi_0 = new double[lambda_length];
         q = new double[p_length];q = new double[p_length];
    }
    
    public double[] q_values(){
        //t_thresold = t;
        long count = 0, count_v = 0;
        
       // System.out.println("WE ARE THERE");
        //for (int t=0; t<lambda_values.length; t++){
        //    System.out.println(lambda_values[t]);
        //}
        
        //calculates lambda values
        for(int index = 0; index < lambda_length; index++){
            count = 0; count_v = 0;
            for(int index_1 = 0; index_1 < p_length; index_1++)
                if(p_values[index_1] >= lambda_values[index]){
                count++;
                count_v += p_values[index_1];
                }
            if(count != 0 & count_v != 0){
             range_pi_0[index] = count_v/((double) count * (1.0 - lambda_values[index]));
            }else{
                range_pi_0[index] = 0;
            }
        }
        
        // Create a CubicSpline instance and initialise it to the data stored in the arrays wavelength and refrindex
        CubicSpline cs =new CubicSpline(lambda_values, range_pi_0);
        
        pi_0_estimator = cs.interpolate(lambda_values[lambda_values.length-1]);
        //System.out.println("pi_estimator is " + pi_0_estimator);
        if(pi_0_estimator > 1) pi_0_estimator = 1;
        
        int[] rank_p = new int[p_length];        
        for(int index = 0; index < p_length; index++){
            rank_p[index] = 1;
            for(int index_j = 0; index_j <index; index_j++){
                if(p_values[index] > p_values[index_j])
                    rank_p[index]++;                
                else if(p_values[index] < p_values[index_j]) 
                    rank_p[index_j]++; 
               // else {
               //     rank_p[index] = rank_p[index_j];
               //     break;
               // }
             }
          }
        
        for (int t=0; t<p_values.length; t++){
            //System.out.println(rank_p[t] + "  " + p_values[t]);
        }
 
        for(int index = 0; index < p_length; index++){
            //if(robust == true)
                q[index] = pi_0_estimator * p_values[index] * p_length/ (double)rank_p[index];
            //else
            //    q[index] = pi_0_estimator * p_length * p_values[index]/(rank_p[index] * (1 - (1 - java.lang.Math.pow(p_values[index],p_length)) ));
            if(q[index] > 1) q[index] = 1;
        }
        
         for (int t=0; t<p_values.length; t++){
          //  System.out.println(q[t] + "  " + p_values[t]);
         }
 
        //double[] sort_p = new double[p_length];
       //java.util.Arrays.sort(rank_p);
       
       
      // for(int index = p_length-2; index >= 0;  index--) {
      //      if(q[rank_p[index+1]] < q[rank_p[index]])
      //          q[rank_p[index]] = q[rank_p[index + 1]];
      // }
        
        return q;
    }
    
}
